Attribute VB_Name = "Derive_Fnct"
'File automatically created by pbProtoTyper.exe (27/07/2009 - 19.47.40)
Option Explicit
Option Base 1
Global Const MODULE_SDIFF = 60
Global Const ANM_SDIFF_NO_ERROR           = -1
Global Const ANM_SDIFF_UndefinedError     = 0 'Undefined error (procedure exit before completion)
Global Const ANM_SDIFF_TooLongFormula     = 1
Global Const ANM_SDIFF_WrongNumber        = 2
Global Const ANM_SDIFF_Wrong1stOperand    = 3
Global Const ANM_SDIFF_WrongBrackets      = 4
Global Const ANM_SDIFF_WrongPowerNumber   = 5
Global Const ANM_SDIFF_ErrorInFormula     = 6
Global Const ANM_SDIFF_EmptyFormula       = 7
Global Const ANM_SDIFF_DivisionByZero     = 8'=#e_DivByZero
'==============================================================================
' Filename: Derive.pb
' Description:
' Library to use symbolic differentiation of mathematical expressions in applications.
' Supports 5 operators, brackets, 18 mathematical functions and userdefined variables
'==============================================================================
Global Const MaxIndex           = 5000
'Derive Returned values (ExitCodes) and Constants
'==================================================
Structure TTree;=record
   opCode.l;
   con.s;
   l.l
   r.l;
EndStructure;
Structure sDiffExpr
      index.l;
       Formula.s
    
       DVar.s;
       Err.b;
       Bc.l;
       PrevLex.l
       Curlex.l;
       Pos.l;
       TreeExpr.l
       TreeDiff.l;
       t.TTree[#MaxIndex]
  
 EndStructure
Global TDfEx.sDiffExpr
Global Dim gCon.s(31)
Global neg.b, DiffLogFName.s
Global r.l,res.l, dummy.l, sDummy.s    ;gNum.l,
Global c.s, cnt.l, DiffLogF.b
Global c_size.l, diffRes.s
Global getLexCallN.l, ResultString$
'
Public Declare Function SetDiffLogF Lib "aNuMet.dll" ( _
       ByVal LogF As Byte,  _
       ByVal LogFileName As String) As Long
' set Log flag on (1) and off (0) and LogFilename

'
Public Declare Function GetLast_diffErr Lib "aNuMet.dll" () As Long
' Return error code of last e_diff() call

'
Public Declare Function GetDiff_OperAndFuncs Lib "aNuMet.dll" ( _
       ByVal sRes As String) As Long
' get a string with the supported operators and functions
' return the lenght of the characters to be copied in the buffer (close to 1000), otherwise 0
' If Not enought buffer space, result will be truncated
' parameters: *sRes pointer/address to a buffer that will contain returned result

'
Public Declare Function e_diff Lib "aNuMet.dll" ( _
       ByVal sExpr As String,  _
       ByVal sVar As String,  _
       ByVal sRes As String,  _
       ByVal sResLen As Long) As Long
' calculate symbolic differentiation of Expr by variable sVar. Store result in buffer sRes
' returns lenght of returned string (space required, even if greater than sResLen),
' otherwise 0 if some differentiation  error occurred.
' See GetLast_diffErr for error code. GetLast_diffErr return no error if result is truncated
' parameters: sExpr: string expression of which calculate symbolic differentiation  (es. "x^2 - 3*x +1")
'            sVar : variable by which calculate                                    (es. "x")
'            *sRes: pointer to a buffer (address) of lenght/dimension sResLen to store result
'            sResLen: length/dimension of sRes buffer (if not enought space, result will be truncated)
' PB sample: ret = e_diff("x^2-e*x+1", "x", @sRes, 100)

