﻿; PureBasic Visual Designer v3.95 build 1485 (PB4Code)

XIncludeFile "anmFuncts.pbi"

;- Window Constants
;
Enumeration #PB_Compiler_EnumerationValue + 1000
    #wndMtx
EndEnumeration

;- Gadget Constants
;
Enumeration #PB_Compiler_EnumerationValue
    #spnRows
    #spnCols
    #lblRows
    #lblCols
    #btnOK
    #btnCopy
    #lblMtxN
    #txtMtxN
    #chkMLine
    #btnGen
    #txtCell
    #lblRC
    #lblOutp
    
    #cntCells
EndEnumeration

Enumeration #PB_Compiler_EnumerationValue
    #mnuMtx
    
    #mnuMtxOpen
    #mnuMtxSave
    #mnuMtxSaveAs
    #mnuMtxExit
    
    #mnuMtxCopy
    #mnuMtxClearCells
    
    #mnuMtxDetermin
    #mnuMtxTranspose
    #mnuMtxInvert
    #mnuMtxOrtog

    #mnuMtxAbout
EndEnumeration


Global OldWndProc

Procedure MtxBalloonTip(WindowID, Gadget, Text$ , Title$, Icon)
  Protected ToolTip, Balloon.TOOLINFO, ln

    ToolTip=CreateWindowEx_(0,"ToolTips_Class32","",#WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON,0,0,0,0,WindowID,0,GetModuleHandle_(0),0)
    SendMessage_(ToolTip,#TTM_SETTIPTEXTCOLOR,GetSysColor_(#COLOR_INFOTEXT),0)
    SendMessage_(ToolTip,#TTM_SETTIPBKCOLOR,GetSysColor_(#COLOR_INFOBK),0)

    StartDrawing(WindowOutput(#wndMtx))
    ln = MaxL(TextWidth(text$), TextWidth(Title$))
    StopDrawing()
    
    SendMessage_(ToolTip, #TTM_SETMAXTIPWIDTH,0,ln*1.2)
;     SendMessage_(ToolTip,#TTM_SETMAXTIPWIDTH,0,180)
    Balloon.TOOLINFO\cbSize=SizeOf(TOOLINFO)
    Balloon\uFlags=#TTF_IDISHWND | #TTF_SUBCLASS
    Balloon\hWnd=GadgetID(Gadget)
    Balloon\uId=GadgetID(Gadget)
    Balloon\lpszText=@Text$
    SendMessage_(ToolTip, #TTM_ADDTOOL, 0, Balloon)
    If Title$ > ""
        SendMessage_(ToolTip, #TTM_SETTITLE, Icon, @Title$)
    EndIf
  
EndProcedure


Procedure Open_wndMtx()
  If OpenWindow(#wndMtx, 249, 0, 350, 320, "Vector / Matrix",  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar )
    ; If CreateGadgetList(WindowID(#wndMtx))
      ;SpinGadget(#spnCols, 150, 10, 45, 20, 0, 100)
        If CreateMenu(#mnuMtx, WindowID(#wndMtx))
;+      MENU LIST
            MenuTitle("&File")
            MenuItem(#mnuMtxOpen, "&Open")
            MenuItem(#mnuMtxSave, "&Save")
            MenuItem(#mnuMtxSaveAs, "Save &As")
            MenuBar()
            MenuItem(#mnuMtxExit, "&Exit")
            
            MenuTitle("&Edit")
            MenuItem(#mnuMtxCopy, "&Copy")
            MenuItem(#mnuMtxClearCells, "C&lear cells")
            
            MenuTitle("&Calculate")
            MenuItem(#mnuMtxDetermin, "&Determinant")
            MenuItem(#mnuMtxTranspose, "&Transpose")
            MenuItem(#mnuMtxInvert, "&Invert")
            MenuItem(#mnuMtxOrtog, "&Ortogonal")
            
            MenuTitle("&Info")
            MenuItem(#mnuMtxAbout, "&About")

        EndIf
              
      StringGadget(#spnCols, 150, 10, 45, 20, "0")
      ;SpinGadget(#spnRows, 45, 10, 45, 20, 0, 100)
      StringGadget(#spnRows, 45, 10, 45, 20, "0")
      TextGadget(#lblRows, 5, 15, 40, 15, "Rows")
      TextGadget(#lblCols, 100, 15, 40, 15, "Columns")
      ButtonGadget(#btnGen, 235, 10, 100, 20, "&Generate Cells")

      ButtonGadget(#btnOK, 235, 40, 50, 20, "&OK", #PB_Button_Default)
      ButtonGadget(#btnCopy, 295, 40, 50, 20, "&Copy")
      
      
      TextGadget(#lblMtxN, 5, 40, 60, 20, "Simb. Nm.")
      StringGadget(#txtMtxN, 65, 37, 45, 20, "[mA]")
      CheckBoxGadget(#chkMLine, 130, 43, 100, 15, "Multi Line (DimX)")
      ;ButtonGadget(#btnGen, 130, 40, 100, 20, "&Generate Cells", #PB_Button_Default)
      TextGadget(#lblRC, 5, 65, 50, 15, "R0,C0")
      StringGadget(#txtCell, 55, 63, 290, 20, "")
      
      StringGadget(#lblOutp, 2, 262, 346, 36, "Output",#PB_String_ReadOnly)
      
      ; GadgetToolTip(#lblOutp, "eeeeeeeeeeeeee")


    ; EndIf
  EndIf
  
  If #PB_Compiler_Debugger
;    SetGadgetState(#spnRows, 4)
    SetGadgetText(#spnRows, "4")
;    SetGadgetState(#spnCols, 4)
    SetGadgetText(#spnCols, "4")
  
    
  EndIf
  
    ;OldWndProc = SetWindowLong_(GadgetID(#lblOutp), #GWL_WNDPROC, @WinCallback())

EndProcedure


; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 6
; FirstLine = 5
; Folding = -
; EnableThread
; UseMainFile = InpMatrix.pb
; Debugger = IDE
; Warnings = Error
; DisableCompileCount = 1