﻿;IncludeFile "aExpEval.pb"
CompilerIf Defined(UseType, #PB_Constant)=0
    #UseDll = 1
    #UseServer = 2
    #UseType = #UseServer

CompilerEndIf

CompilerIf #UseType = #UseDLL          ; use DLL
    ; XIncludeFile "anmFuncts.pbi"
    ;XIncludeFile "Solver.pbpt"
    
CompilerElse

;     CompilerIf #UseType = #UseServer      ;Use Server
;         IncludeFile "C:\Program Files\PureBasic_420\Arch\aNuMet_v031\aExpEval\anm_cs.pb"
;         XIncludeFile "..\AuxFunct.pb"
;         
;     CompilerElse
    
        ;IncludePath "..\"
        ;IncludeFile "Solver.pb"
;         XIncludeFile "C:\Program Files\PureBasic_430\Arch\anmXNpp\Derive.pb"     ;Include Solver.pb
;         
;     CompilerEndIf
    
CompilerEndIf

; { - Enumerations / DataSections
; { Windows
; Enumeration 100
; ;  #wPlot
; EndEnumeration
; }
; { Gadgets
; Enumeration 110
; ;   #btnRedraw
; ;   #btnClosePlot
; ;   #ImgPlot
; ;   #lblRedraw
; ;   #txtFrom
; ;   #lblTo
; ;   #txtTo
; EndEnumeration
; }
Dim btnRedraw.l(0)
Dim btnClosePlot.l(0)
Dim lblRedraw.l(0)
Dim txtFrom.l(0)
Dim lblTo.l(0)
Dim txtTo.l(0)

Dim expr.s(0)
Dim x0.d(0) : Dim sVar.s(0) : Dim xN.d(0) : Dim N1.l(0)
Dim Xv.d(1) : Dim Yv.d(1)

Dim MinXv.d(0) : Dim MaxXv.d(0) : Dim MinYv.d(0) : Dim MaxYv.d(0) : Dim dXv.d(0) : Dim dYv.d(0) : 

Global ScaleImgDef.l, PlotIdDef.l
Global lGexpr.s, lGsVar.s, mx.l, my.l, N1.l

Procedure.l ShowGadgetCoord(lplot.l, cmt.s = "")
Shared btnRedraw()
Shared btnClosePlot()
Shared lblRedraw()
Shared txtFrom()
Shared lblTo()
Shared txtTo()

;     Debug ""
;     Debug cmt+", plot = "+Str(lplot)
;     Debug "  btnRedraw = "+Str(btnRedraw(lplot))
;         Debug GadgetX(btnRedraw(lplot))
;         Debug GadgetY(btnRedraw(lplot))
;     Debug "  btnClosePlot = "+Str(btnClosePlot(lplot))
;         Debug GadgetX(btnClosePlot(lplot))
;         Debug GadgetY(btnClosePlot(lplot))
;     Debug "  lblRedraw = "+Str(lblRedraw(lplot))
;         Debug GadgetX(lblRedraw(lplot))
;         Debug GadgetY(lblRedraw(lplot))
;
;     Debug "  txtFrom = "+Str(txtFrom(lplot))
;         Debug GadgetX(txtFrom(lplot))
;         Debug GadgetY(txtFrom(lplot))
;     Debug "  lblTo = "+Str(lblTo(lplot))
;         Debug GadgetX(lblTo(lplot))
;         Debug GadgetY(lblTo(lplot))
;     Debug "  txtTo = "+Str(txtTo(lplot))
;         Debug GadgetX(TxtTo(lplot))
;         Debug GadgetY(TxtTo(lplot))
    
EndProcedure

Procedure.l OpenWindow_wPlot(lplot.l)
Protected Event.l, EventWindow.l, EventGadget.l, EventType.l, EventMenu.l, ret.l
Shared WndPlot()
;Shared ImgPlots()
Shared btnRedraw()
Shared btnClosePlot()
Shared lblRedraw()
Shared txtFrom()
Shared lblTo()
Shared txtTo()

Protected x1.l, y1.l, w1.l, h1.l, ky.l, kx.l, bw.l
    kx = 7 : bw = 30
    w1 = 400;DesktopWidth / 3
    h1 = 400;DesktopHeight / 3
    If plots>1 And IsWindow(WndPlot(lplot-1))
        x1 = WindowX(WndPlot(lplot-1)) + WindowWidth(WndPlot(lplot-1)) + kx
        ExamineDesktops()
        If x1 + w1>DesktopWidth(0)
            ky = h1 + bw
            x1 = 0
        EndIf
        y1 = ky + WindowY(WndPlot(lplot-1))
    Else
        x1 = 0
        y1 = 0
    EndIf
    
;    WndPlot(Plots) = OpenWindow(#PB_Any, 400, 142, 400, 400, "aPlot", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
;    ret = OpenWindow(WndPlot(lplot), 400, 142, 400, 400, "aPlot #"+Str(lplot), #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
    ret = OpenWindow(WndPlot(lplot), x1, y1, w1, h1, "aPlot #" + Str(lplot), #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
    If ret
    
        ;Plots incrementa in aExpEval.pb
        
        ;If CreateGadgetList(WindowID(WndPlot(lplot)))

            ButtonGadget(btnRedraw(lplot), 5, 375, 75, 20, "Redraw")
            ButtonGadget(btnClosePlot(lplot), 320, 375, 75, 20, "Close")
            
            TextGadget(lblRedraw(lplot), 90, 378, 70, 20, "Redraw from")
            StringGadget(txtFrom(lplot), 160, 375, 50, 20, "0")
            TextGadget(lblTo(lplot), 220, 378, 20, 20, "to")
            StringGadget(txtTo(lplot), 240, 375, 50, 20, "0")
            
            SmartWindowRefresh(WndPlot(lplot), 1)

            ShowGadgetCoord(lplot, "OpenWindow")
        ;EndIf
    EndIf
  
  ProcedureReturn ret
  
EndProcedure

Procedure.d ScaleXf(xv.d, ObjId.l = 0, PlotId.l = 0)
Define xf.d, ImgWidthF.d, ScaleWidthV.d
Shared MinXv.d() : Shared MaxXv.d() : Shared dXv.d() : 

    If ObjId = 0 : ObjId = ScaleImgDef : EndIf
    If PlotId = 0 : PlotId = PlotIdDef : EndIf

    ScaleWidthV = (MaxXv(PlotId)-MinXv(PlotId))
    ImgWidthF = ImageWidth(ObjId)
    
    xf = (xv-dXv(PlotId))*ImgWidthF/ScaleWidthV
    ;xf = xv * ImgWidthF / ScaleWidthV - X0f
    
    ProcedureReturn xf
    
EndProcedure

Procedure.d ScaleXv(Xf.d, ObjId.l = 0, PlotId.l = 0)
Define Xv.d, ImgWidthF.d, ScaleWidthV.d
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    If ObjId = 0 : ObjId = ScaleImgDef : EndIf
    If PlotId = 0 : PlotId = PlotIdDef : EndIf

    ScaleWidthV = (MaxXv(PlotId)-MinXv(PlotId))
    
    ImgWidthF = ImageWidth(ObjId)
    
    ;Xf = (xv - dXv) * ImgWidthF / ScaleWidthV
    
    Xv = Xf*ScaleWidthV/ImgWidthF + dXv(PlotId)
    
    ProcedureReturn Xv
    
EndProcedure

Procedure.d ScaleYf(yv.d, ObjId.l = 0, InvY.b = 1, PlotId.l = 0)
Define yf.d, ImgHeightF.d, ScaleHeightV.d
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    If ObjId = 0 : ObjId = ScaleImgDef : EndIf
    If PlotId = 0 : PlotId = PlotIdDef : EndIf

    ScaleHeightV = (MaxYv(PlotId)-MinYv(PlotId))
    ImgHeightF = ImageHeight(ObjId)
    
    yf = (yv-dYv(PlotId))*ImgHeightF/ScaleHeightV
    ;yf = yv* ImgHeightF / ScaleHeightV - Y0f
    
    ProcedureReturn yf
    
EndProcedure

Procedure.d ScaleYv(Yf.d, ObjId.l = 0, InvY.b = 1, PlotId.l = 0)
Define Yv.d, ImgHeightF.d, ScaleHeightV.d
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    If ObjId = 0 : ObjId = ScaleImgDef : EndIf
    If PlotId = 0 : PlotId = PlotIdDef : EndIf
    
    ScaleHeightV = (MaxYv(PlotId)-MinYv(PlotId))
    
    ImgHeightF = ImageHeight(ObjId)
    
    ;Yf = (Yv - dYv) * ImgHeightF / ScaleHeightV
    Yv = Yf*ScaleHeightV/ImgHeightF + dYv(PlotId)
    
    ProcedureReturn Yv
    
EndProcedure

Procedure.l DrawAxis(MaxYf.d, MinYf.d, lplot.l)
Define x1.d, x2.d, y1.d, y2.d
Shared ImgPlots()
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    FrontColor(RGB(255, 255, 255))                                ;white
    
    x1 = ScaleXf(MinXv(lplot)) : x2 = ScaleXf(MaxXv(lplot))
    ;y1 = ScaleYf(0): y2 = ScaleYf(0)                           ;x axis
    y1 = MaxYf-ScaleYf(0) : y2 = MaxYf-ScaleYf(0)
    LineXY(x1, y1, x2, y2)
    
    x1 = ScaleXf(0) : x2 = ScaleXf(0)                            ;y axis
    y1 = ImageHeight(ImgPlots(lplot));MaxYf - MinYf;ScaleYf(MinYv):
    y2 = 0; MaxYf - ScaleYf(MaxYv)
    LineXY(x1, y1, x2, y2)

    x1 = ScaleXf(0) : y1 = ScaleYf(0)
    ;if y1 < 0 do nothing
    DrawText(x1-TextWidth("0,0")/2, MaxYf-y1, "0,0", 0)   ;0,0
    
    x1 = ScaleXf(MinXv(lplot)) : 
    y1 = ScaleYf(0) : If y1<0 : y1 = TextHeight("I") + 2 : EndIf
    DrawText(x1 + 2, MaxYf-y1, Str(MinXv(lplot)), 0)                           ;MinX
    
    x1 = ScaleXf(MaxXv(lplot)) : 
    y1 = ScaleYf(0) : If y1<0 : y1 = TextHeight("I") + 2 : EndIf
    DrawText(x1-1.2*TextWidth(Str(MaxXv(lplot))), MaxYf-y1, Str(MaxXv(lplot)), 0)   ;MaxX
    
    y1 = MaxYf-ScaleYf(MinYv(lplot))-TextHeight("I")-2
    ;Debug "y1 = " +StrD(y1)
    DrawText(ScaleXf(2), y1, Trim0s(StrD(MinYv(lplot), 2)), 0)            ;MinY
    
    y2 = ScaleYf(MaxYv(lplot))
    y2 = MaxYf-y2-2
    ;Debug "y2 = " +StrD(y2)
    DrawText(ScaleXf(2), y2, Trim0s(StrD(MaxYv(lplot), 2)), 0)            ;MaxY

EndProcedure

Procedure.l DrawCurve(lplot.l)
Protected ret.l, i.l, dbl.d, x1.d, x2.d, y1.d, y2.d, WPlot.l, Font1.l, st.s
Shared Xv.d() : Shared Yv.d()
Shared WndPlot()
Shared ImgPlots()
Shared txtFrom()
Shared txtTo()
Shared expr() : Shared N1()
Shared MinXv() : Shared MaxXv() : Shared MinYv() : Shared MaxYv() : Shared dXv() : Shared dYv() : 
    
    wPlot = WndPlot(lplot)
    
    Define xf.d, yf.d, xf0.d, yf0.d;dimensioni fisiche (reali in pixel) del grafico. Dipendono dalle dimensioni del form
    Define MinXf.d, MinYf.d, MaxXf.d, MaxYf.d

    PlotIdDef = lplot

    MinXf = 0 : MinYf = 0 : MaxXf = WindowWidth(wPlot) : MaxYf = WindowHeight(wPlot)-35-20
    dXv(lplot) = MinXv(lplot) : dYv(lplot) = MinYv(lplot)

    ;ReDim ImgPlots.l(lplot)
;    ImgPlots(lplot) = CreateImage(#PB_Any, MaxXf, WindowHeight(wPlot)-35);MaxYf)
    CreateImage(ImgPlots(lplot), MaxXf, WindowHeight(wPlot)-35);MaxYf)
    ScaleImgDef = Imgplots(lplot)
    ;GetWndSnapShot(wPlot, "0")

    Font1 = LoadFont(#PB_Any, "Verdana", 8, 0)

    ret = StartDrawing(ImageOutput(ImgPlots(lplot)))
    DrawingFont(FontID(Font1))

    xf0 = ScaleXf(Xv(0))
    yf0 = ScaleYf(Yv(0))
    
;     Debug "MinYf = "+StrD(MinYf)
;     Debug "MaxYf = "+ StrD(MaxYf)
;     Debug "ImgWidth = "+StrD(ImageWidth(ImgPlots(lplot)))
;     Debug "ImgHeight = "+ StrD(ImageHeight(ImgPlots(lplot)))
    
    ;draw the curve
    FrontColor(RGB(255, 0, 0))                                    ;red
    
    For i = 0 To N1(lplot)
        xf = ScaleXf(Xv(i))
                
        If StrD(Yv(i))<>"1.#INF000000"
            yf = MaxYf-ScaleYf(Yv(i))
        Else
            ;i = i
            Continue
        EndIf
        
        If i>0
            LineXY(xf0, yf0, xf, yf)
        EndIf
        ;Plot(xf, yf)
        
        xf0 = xf
        yf0 = yf
      
    Next i
    
    DrawText(0, 0, "Expr = " + expr(lplot))
    DrawAxis(MaxYf, MinYf, lplot)
    
    StopDrawing()

    ;GetWndSnapShot(wPlot, "0")
    
    ;Debug WindowID(wPlot)
    ;If CreateGadgetList(WindowID(wPlot))
        ret = ImageGadget(ImgPlots(lplot), 0, 0, MaxXf, WindowHeight(wPlot)-35, ImageID(ImgPlots(lplot)), #PB_Image_Border)
    ;EndIf

    ;GetWndSnapShot(wPlot, "0")

    st = Trim0s(StrD(Xv(0)))
    SetGadgetText(txtFrom(lPlot), st)
    st = Trim0s(StrD(Xv(N1(lplot))))
    SetGadgetText(txtTo(lplot), st)

EndProcedure

Procedure.l CalcExpression(lexpr.s = "", lx0.d = 0, lsVar.s = "", lxN.d = 0, lN1.l = 0, lplot.l = 0)
Define st1.s, x.d, delta.d
Protected expr2.s, ret.l, Y.d, i.l, StrDx.s, k.l
Shared expr() : Shared sVar() : Shared N1() : Shared x0() : Shared xN()
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    If lexpr = "" : lexpr = expr(lplot) : EndIf
    If lsVar = "" : lsVar = sVar(lplot) : EndIf
    If lx0 = 0 : lx0 = x0(lplot) : EndIf
    If lxN = 0 : lxN = xN(lplot) : EndIf
    If lN1 = 0 : lN1 = N1(lplot) : EndIf

    delta = (lxN-lx0)/lN1
    x = lx0 : i = 0
    
    Shared Xv.d() : Shared Yv.d()
    ReDim Xv.d(lN1) : ReDim Yv.d(lN1)
    Dim MinMaxXY.d(4);to semplify expression
    
    If #UseType = #UseServer
        ;OnErrorResume()
        
        ret = e_evals(lexpr, lx0, lsVar, lxN, lN1, @Xv(0), @Yv(0), @MinMaxXY(0))
        
        MinXv(lplot) = MinMaxXY(1)
        MinYv(lplot) = MinMaxXY(2)
        MaxXv(lplot) = MinMaxXY(3)
        MaxYv(lplot) = MinMaxXY(4)
        
        OnErrorExit()
        
    Else
        ;ChangeRegType(2)
        While x< = lxN
            
            StrDx = "(" + trim0s(StrD(x)) + ")"
    ;         If x = 0:
    ;             x=x
    ;         EndIf
            expr2 = ReplaceString(lexpr, lsVar, StrDx)                           ;single variable, faster routine
            ret = e_eval(expr2, @y, 0)
            
            If GetE_Error() = #ANM_EVAL_no_error
    ;        If ret = #e_evalOK Or ret = 0
    
                If i>0
                    If MinXv(lplot)>x : MinXv(lplot) = x : EndIf
                    If MinYv(lplot)>Y : MinYv(lplot) = Y : EndIf
                            
                    If MaxXv(lplot)<x : MaxXv(lplot) = x : EndIf
                    If MaxYv(lplot)<Y : MaxYv(lplot) = Y : EndIf
                Else
                    ;
                    
                    MinXv(lplot) = lx0
                    MaxXv(lplot) = lx0
                    
                    MinYv(lplot) = Y
                    MaxYv(lplot) = Y
                EndIf
                
    ;         Else
    ;             i=i
            EndIf
            
            Xv(i) = x : Yv(i) = y
            x = x + delta
            i = i + 1
        
        Wend
    EndIf

    ;ChangeRegType(RegType1)
    
EndProcedure

Procedure.s FileOutPlot(param.s, CurDir.s)
Protected sRet$, ret.l, fn.s, st.s, i.l
Shared Xv.d() : Shared Yv.d()

    sRet$ = ""
    fn = param;to keep u/lcases in filename
    param = LCase(param)
    
    If Mid(fn, 2, 1) = ":"
        fn = CurDir + fn
        
    EndIf
            
    st = "Id" + Chr(9) + "X" + Chr(9) + "Y" + #CRLF$
    For i = 0 To N1
                 
        If StrD(Yv(i)) = "1.#INF000000"
            Continue
        EndIf

        st = st + Str(i) + Chr(9) + Trim0s(StrD(Xv(i))) + Chr(9) + Trim0s(StrD(Yv(i))) + #CRLF$
        
    Next i
               
    If OpenFile(0, fn)
        WriteString(0, st)
        FlushFileBuffers(0)
        CloseFile(0)
    Else
        ret = MessageRequester("aExpEval", "Error: can't write the file." + CR + fn, 0)
    EndIf
  
    sRet$ = st
    ProcedureReturn sRet$

EndProcedure

Procedure.l aPlotExpr(riga$, pos.l, par1.l, par2.l, lplot.l) ;Plot(-100; x; 100; 200) = 1 + 12*x - 3*x^3 + 2x^4 - 5x^5
Protected params.s, OutF.s, ret.l
Shared ImgPlots() : Shared WndPlot()
Shared expr() : Shared x0() : Shared sVar() : Shared xN() : Shared N1()
Shared MinXv.d() : Shared MaxXv.d() : Shared MinYv.d() : Shared MaxYv.d() : Shared dXv.d() : Shared dYv.d() : 

    ReDim expr.s(plots) : ReDim x0.d(plots) : ReDim sVar.s(plots) : ReDim xN.d(plots) : ReDim N1.l(plots)
    ReDim MinXv.d(plots) : ReDim MaxXv.d(plots) : ReDim MinYv.d(plots) : ReDim MaxYv.d(plots) : ReDim dXv.d(plots) : ReDim dYv.d(plots) : 
    
    ret = OpenWindow_wPlot(lplot)

    expr(lplot) = Trim(Mid(riga$, pos+1)) ;1. expression or 2. matrexpr
    lGexpr = expr(lplot)
    params = Trim(Mid(riga$, par1+1, par2-par1-1))
    x0(lplot) = ValD(StringField(params+";", 1, ";"))
    sVar(lplot) = Trim(LCase(StringField(params+";", 2, ";")))
    lGsVar = sVar(lplot)
    xN(lplot) = ValD(StringField(params+";", 3, ";"))
    N1(lplot) = ValD(StringField(params+";", 4, ";"))
    OutF = Trim(StringField(params+";", 5, ";"))
    ; If Trim(StringField(params+";", 6, ";")) <> "": splF = 1: Else : splF = 0: EndIf ; splF SavePlotsInPath
    
; SetGadgetText(#txtFrom, Trim0s(StrD(x0)))
; SetGadgetText(#txtTo, Trim0s(StrD(xN)))
;
    CalcExpression(expr(lplot), x0(lplot), sVar(lplot), xN(lplot), N1(lplot), lplot)
    
    If OutF <> ""
        FileOutPlot(OutF, CurDir)
    EndIf
    ;GetWndSnapShot(wPlot, "0")
    
    DrawCurve(lplot)
    
    ;GetWndSnapShot(WndPlot(lplot), "0")

    ;keybd_event_(#VK_SNAPSHOT,1,0,0) ; Snapshot of current active window.
    
    ;Sleep_(1000)
    
    ProcedureReturn WndPlot(lplot)
    
EndProcedure

Procedure.l aPlot_EventLoop(EventObj.l, EventWnd.l, EventGadget.l, EventType.l, *wParam)
Protected mx.l, my.l, st.s, ret.l, Xv.d, Yv.d, decX.b, decY.b, plot.l
Static pst.s
; EventObj
; #PB_Event_Menu : a menu has been selected
; #PB_Event_Gadget : a gadget has been pushed
; #PB_Event_SysTray : an icon in the systray zone was clicked
; #PB_Event_CloseWindow : the window close gadget has been pushed
; #PB_Event_Repaint : the window content has been destroyed And must be repainted (useful For 2D graphics operations)
; #PB_Event_SizeWindow : the window has been resized
; #PB_Event_MoveWindow : the window has been moved
; #PB_Event_ActivateWindow : the window has been activated (got the focus)
; #PB_Event_WindowDrop : a Drag & Drop operation was finished on a window
; #PB_Event_GadgetDrop : a Drag & Drop operation was finished on a gadget

Shared WndPlot(): Shared ImgPlots()
Shared btnRedraw()
Shared btnClosePlot()
Shared lblRedraw()
Shared txtFrom()
Shared lblTo()
Shared txtTo()
Protected x0.d, xN.d, wParam.l

If *wParam> 0: wParam = PeekL(*wParam): EndIf

For plot = 1 To Plots
    ;wnd = WndPlot(plot)
 
    If WndPlot(plot) <> 0 And EventWnd = WndPlot(plot) And IsWindow(WndPlot(plot))
        
        Select EventObj
        Case #WM_CHAR
            If wParam = #VK_ESCAPE
                SetActiveWindow(0)
                CloseWindow(WndPlot(Plot))
                ;Plots = Plots - 1
                WndPlot(Plot) = 0
                wParam = #Null ;null param to avoid closure of program
                PokeL(*wParam, wParam)
            EndIf
        
        Case #PB_Event_Gadget
        
            If EventGadget = ImgPlots(Plot)
            
                Select EventType
                Case #PB_EventType_LeftClick, #PB_EventType_RightClick
        ; If wPlot
                        mx = WindowMouseX(WndPlot(Plot))
                        my = WindowMouseY(WndPlot(Plot))
                        
                        Xv = ScaleXv(mx)
                        Yv = ScaleYv(my)
                        
                        If mx > -1 And my > -1
                            If Abs(Xv)>100: decX = 0:Else: decX = 4: EndIf
                            If Abs(Yv)>100: decY = 0:Else: decY = 4: EndIf
                            st = "Coord: "+Trim0s(StrD(Xv, decx)) + ", "+Trim0s(StrD(Yv, decy))
                            ;st = "MousePos: "+Str(mx) + ", "+Str(my)
                        Else
                            st = "MousePos: out of window"
                        EndIf
                        
                        If st <> pst
                            GadgetToolTip(ImgPlots(Plot), st)
                            Delay(10)
                        EndIf
                        pst = st
                        
                        ;Debug st
        ; EndIf
                
                EndSelect
                    
            ElseIf EventGadget = btnRedraw(Plot)
                x0 = ValD(GetGadgetText(txtFrom(Plot)))
                xN = ValD(GetGadgetText(txtTo(Plot)))
                
                CalcExpression("",x0, "", xN, 0, Plot)
                DrawCurve(Plot)
                
            ElseIf EventGadget = btnClosePlot(Plot)
                CloseWindow(WndPlot(Plot))
                ;Plots = Plots - 1
                WndPlot(Plot) = 0
        
            EndIf
        ;Case #PB_Event_ActivateWindow
        
        Case #PB_Event_CloseWindow ;EventObj
            If IsWindow(0): SetActiveWindow(0): endif
            CloseWindow(WndPlot(Plot))
            ;Plots = Plots - 1
            WndPlot(Plot) = 0
            
        Case #PB_Event_SizeWindow;, #PB_Event_Repaint ;EventObj
            Delay(10)
            Protected wh1.l
                ;Debug "4a - "+Str(ImgPlot)
             ResizeGadget(ImgPlots(Plot), #PB_Ignore, #PB_Ignore, WindowWidth(WndPlot(Plot)), WindowHeight(WndPlot(Plot)) -35)
             CalcExpression("",x0, "", xN, 0, Plot)
             DrawCurve(Plot)

             ;Debug "4b - "+Str(ImgPlot)
             wh1 = WindowHeight(WndPlot(Plot))-5-20
             
            ;MessageRequester("", Str(#btnRedraw))
             ResizeGadget(btnRedraw(Plot), 5, wh1, #PB_Ignore, #PB_Ignore)

             ResizeGadget(btnClosePlot(Plot), WindowWidth(WndPlot(Plot))-5-75, wh1, #PB_Ignore, #PB_Ignore)
             
             ;GetWndSnapShot(WndPlot(Plot), "0")
              TextGadget(lblRedraw(Plot), 90, wh1+3, 70, 20, "Redraw from")
              
              st = GetGadgetText(txtFrom(Plot))
              StringGadget(txtFrom(Plot), 160, wh1, 50, 20, st)
              
              TextGadget(lblTo(Plot), 220, wh1+3, 20, 20, "to")
              
              st = GetGadgetText(txtTo(Plot))
              StringGadget(txtTo(Plot), 240, wh1, 50, 20, st)

                x0 = ValD(GetGadgetText(txtFrom(Plot)))
                xN = ValD(GetGadgetText(txtTo(Plot)))
              ;Debug "4c - "+Str(ImgPlot)
              ShowGadgetCoord(plot,"#PB_Event_SizeWindow")
              
        EndSelect
        
    EndIf
Next plot

ProcedureReturn Plots
    
EndProcedure



; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 590
; FirstLine = 565
; Folding = ---
; EnableUnicode
; Executable = ..\..\anmEval_v0030\aExpEval.exe
; EnableCompileCount = 0
; EnableBuildCount = 0
; IncludeVersionInfo
; VersionField0 = 0.0.2.0
; VersionField1 = 0.0.2.0
; VersionField2 = - - -
; VersionField3 = aExpEval
; VersionField6 = Evaluator and Plotter of expressions, functions, integrals, matrices, etc
; VersionField7 = aExpEval
; VersionField8 = aExpEval
; VersionField13 = somic@libero.it
; VersionField14 = http://www.semelinanno.com/